global _NESSIEisboxa
global _NESSIEsboxa
global _NESSIEsboxb
global _NESSIEisboxb
global _NESSIEsboxc
global _NESSIEbytesub
global _NESSIEbytesubAB
global _NESSIEround
global _NESSIEblank
global _starttsc
global _gettsc

extern _byteS
extern _invbyteS
extern _byteSxor
extern _invbyteSxor

;the nessie structure as defined for c
                struc NESSIEstruct
byteSx:         resd 256
byteS2:         resd 256
byteS3:         resd 256
byteS4:         resd 256
invbyteSx:      resd 256
invbyteS2:      resd 256
invbyteS3:      resd 256
invbyteS4:      resd 256
keyW1:          resb 16
keyA:           resb 16
keyB:           resb 16
key0:           resb 16
key1:           resb 16
key2:           resb 16
key3:           resb 16
key4:           resb 16
key5:           resb 16
key6:           resb 16
key7:           resb 16
keyW2:          resb 16
                endstruc

; the structure of the stack
ebxaddr         equ 0
ediaddr         equ 4
esiaddr         equ 8
ebpaddr         equ 12
returnaddr      equ 16
frame           equ 20
plaintext       equ 0
ciphertext      equ 4

%define r0 eax
%define r1 ebx
%define r2 ecx
%define r3 edx
%define r4 edi

;does sboxa
_NESSIEsboxa:   push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]
                mov r0,[esi+0]
                mov r1,[esi+4]
                mov r2,[esi+8]
                mov r3,[esi+12]

                ;start inverse s-box A
                mov r4,r0              ;mov 4,0
                xor r0,r1              ;xor 0,1
                ;should synchronize for pentium here
                xor r0,r2              ;xor 0,2
                xor r1,r3              ;xor 1,3
                or r4,r0               ;or 4,0
                and r2,r0              ;and 2,0
                xor r1,r4              ;xor 1,4
                xor r4,r2              ;xor 4,2
                mov r2,r4              ;mov 2,4
                and r4,r1              ;and 4,1
                xor r4,r0              ;xor 4,0
                xor r0,r3              ;xor 0,3
                and r0,r1              ;and 0,1
                xor r3,r4              ;xor 3,4
                xor r0,r3              ;xor 0,3
                xor r2,r3              ;xor 2,3

                mov esi,[esp+ciphertext+frame]
                mov [esi+0],r1
                mov [esi+4],r4
                mov [esi+8],r0
                mov [esi+12],r2

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret

;does the inverse sboxa
_NESSIEisboxa:  push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]
                mov r1,[esi+0]
                mov r3,[esi+4]
                mov r2,[esi+8]
                mov r0,[esi+12]

                ;start inverse sboxa
                mov r4,r0     ;mov 4,0
                and r0,r1     ;and 0,1
                ;should synchronize for pentium here
                xor r0,r2     ;xor 0,2
                mov r2,r4     ;mov 2,4
                xor r4,r0     ;xor 4,0
                xor r2,r1     ;xor 2,1
                and r1,r4     ;and 1,4
                xor r0,r3     ;xor 0,3
                xor r1,r3     ;xor 1,3
                and r3,r4     ;and 3,4
                xor r3,r2     ;xor 3,2
                mov r2,r1     ;mov 2,1
                or r1,r3      ;or 1,3
                and r2,r3     ;and 2,3
                xor r1,r4     ;xor 1,4
                xor r2,r4     ;xor 2,4

                mov esi,[esp+ciphertext+frame]
                mov [esi+0],r2
                mov [esi+4],r3
                mov [esi+8],r1
                mov [esi+12],r0

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret

;does sboxb
_NESSIEsboxb:   push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]
                mov r0,[esi+0]
                mov r1,[esi+4]
                mov r2,[esi+8]
                mov r3,[esi+12]

                ;start s-box b
                mov r4,r0       ;r4 = r0
                or r0,r3        ;r0|= r3
                ;should synchronize for pentium here
                xor r3,r1       ;r3^= r1
                and r1,r4       ;r1&= r4
                xor r4,r2       ;r4^= r2
                xor r2,r3       ;r2^= r3
                and r3,r0       ;r3&= r0
                or r4,r1        ;r4|= r1
                xor r3,r4       ;r3^= r4
                xor r0,r1       ;r0^= r1
                and r4,r0       ;r4&= r0
                xor r1,r3       ;r1^= r3
                xor r4,r2       ;r4^= r2
                or r1,r0        ;r1|= r0
                xor r1,r2       ;r1^= r2
                xor r0,r3       ;r0^= r3
                mov r2,r1       ;r2 = r1
                or r1,r3        ;r1|= r3
                xor r1,r0       ;r1^= r0

                mov esi,[esp+ciphertext+frame]
                mov [esi+0],r1
                mov [esi+4],r2
                mov [esi+8],r3
                mov [esi+12],r4

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret

;does inverse sboxb
_NESSIEisboxb:   push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]
                mov r0,[esi+0]
                mov r1,[esi+4]
                mov r2,[esi+8]
                mov r3,[esi+12]

                ;start inverse s-box b
                mov r4,r2       ;r4 = r2
                xor r2,r1       ;r2^= r1
                ;should synchronize for pentium here
                xor r0,r2       ;r0^= r2
                and r4,r2       ;r4&= r2
                xor r4,r0       ;r4^= r0
                and r0,r1       ;r0&= r1
                xor r1,r3       ;r1^= r3
                or r3,r4        ;r3|= r4
                xor r2,r3       ;r2^= r3
                xor r0,r3       ;r0^= r3
                xor r1,r4       ;r1^= r4
                and r3,r2       ;r3&= r2
                xor r3,r1       ;r3^= r1
                xor r1,r0       ;r1^= r0
                or r1,r2        ;r1|= r2
                xor r0,r3       ;r0^= r3
                xor r1,r4       ;r1^= r4
                xor r0,r1       ;r0|= r1

                mov esi,[esp+ciphertext+frame]
                mov [esi+0],r2
                mov [esi+4],r1
                mov [esi+8],r3
                mov [esi+12],r0

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret

;does sboxc
_NESSIEsboxc:   push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]
                mov r0,[esi+0]
                mov r1,[esi+4]
                mov r2,[esi+8]
                mov r3,[esi+12]

                ;start inverse s-box b
                xor r0,r1       ;xor 0,1
                mov r4,r2       ;mov 4,2
                ;should synchronize for pentium here
                xor r2,r3       ;xor 2,3
                xor r3,r1       ;xor 3,1
                or r2,r0        ;or 2,0
                and r3,r0       ;and 3,0
                xor r3,r2       ;xor 3,2
                xor r2,r1       ;xor 2,1
                or r1,r3        ;or 1,3
                xor r4,r2       ;xor 4,2
                xor r0,r2       ;xor 0,2
                xor r1,r4       ;xor 1,4
                or r4,r0        ;or 4,0
                xor r2,r3       ;xor 2,3
                xor r0,r1       ;xor 0,1
                xor r2,r4       ;xor 2,4

                mov esi,[esp+ciphertext+frame]
                mov [esi+0],r3
                mov [esi+4],r1
                mov [esi+8],r0
                mov [esi+12],r2

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret

%define r5 esi
;uses _byteS to do the byte substitution
_NESSIEbytesub: push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]   ;cycle
                mov ebp,_byteSxor
                mov r0,[esi+0]          ;cycle
                mov r1,[esi+4]          ;cycle
                mov r2,[esi+8]          ;cycle
                mov r3,[esi+12]         ;cycle

                ;do 00 10 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5

                ;do 20 30 pair of bytes
                rol r0,8                ;cycle
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 01 11 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 21 31 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 02 12 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 22 32 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 03 13 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 03 13 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                mov ebp,[esp+ciphertext+frame]
                mov [ebp+0],r0
                mov [ebp+4],r1
                mov [ebp+8],r2
                mov [ebp+12],r3

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret

;%undef plaintext
;%undef ciphertext
%define strucptr 0
%define plaintext 4
%define ciphertext 8

_NESSIEbytesubAB: push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]   ;cycle
                mov ebp,_byteSxor
                mov edi,[esp+strucptr+frame]    ;cycle
                mov r0,[esi+0]          ;cycle
                mov r1,[esi+4]          ;cycle
                mov r2,[esi+8]          ;cycle
                mov r3,[esi+12]         ;cycle
                xor r0,[edi+keyA]       ;cycle
                xor r1,[edi+keyA+4]     ;cycle
                xor r2,[edi+keyA+8]     ;cycle
                xor r3,[edi+keyA+12]    ;cycle
                
                ;do 00 10 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5

                ;do 20 30 pair of bytes
                rol r0,8                ;cycle
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 01 11 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 21 31 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 02 12 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 22 32 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 03 13 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 03 13 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                mov edi,[esp+strucptr+frame]    ;cycle
                xor r0,[edi+keyB]       ;cycle
                xor r1,[edi+keyB+4]     ;cycle
                xor r2,[edi+keyB+8]     ;cycle
                xor r3,[edi+keyB+12]    ;cycle
                

                mov ebp,[esp+ciphertext+frame]
                mov [ebp+0],r0
                mov [ebp+4],r1
                mov [ebp+8],r2
                mov [ebp+12],r3

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret

%define rcnt 12

_NESSIEround:   push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]   ;cycle
                mov ebp,_byteSxor
                mov edi,[esp+strucptr+frame]    ;cycle
                mov r0,[esi+0]          ;cycle
                mov r1,[esi+4]          ;cycle
                mov r2,[esi+8]          ;cycle
                mov r3,[esi+12]         ;cycle
                xor r0,[edi+keyA]       ;cycle
                xor r1,[edi+keyA+4]     ;cycle
                xor r2,[edi+keyA+8]     ;cycle
                xor r3,[edi+keyA+12]    ;cycle
                
                ;do 00 10 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5

                ;do 20 30 pair of bytes
                rol r0,8                ;cycle
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 01 11 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 21 31 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 02 12 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 22 32 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                ;do 03 13 pair of bytes
                mov r4,r0
                mov r5,r1               ;cycle
                and r4,255
                rol r2,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r0,r4
                rol r3,8                ;cycle
                xor r1,r5
                rol r0,8                ;cycle

                ;do 03 13 pair of bytes
                mov r4,r2
                mov r5,r3               ;cycle
                and r4,255
                rol r1,8                ;cycle
                and r5,255
                mov r4,[ebp+r4*4]       ;cycle
                mov r5,[ebp+r5*4]       ;cycle
                xor r2,r4
                xor r3,r5               ;cycle

                mov ebp,[esp+strucptr+frame]    ;cycle
                xor r0,[ebp+keyB]       ;cycle
                xor r1,[ebp+keyB+4]     ;cycle
                xor r2,[ebp+keyB+8]     ;cycle
                xor r3,[ebp+keyB+12]    ;cycle
                
                ;start inverse s-box A
                mov r4,r0              ;mov 4,0         -c
                xor r0,r1              ;xor 0,1
                ;should synchronize for pentium here
                xor r0,r2              ;xor 0,2         -c
                xor r1,r3              ;xor 1,3
                or r4,r0               ;or 4,0          -c
                and r2,r0              ;and 2,0
                xor r1,r4              ;xor 1,4         -c
                xor r4,r2              ;xor 4,2
                mov r2,r4              ;mov 2,4         -c
                and r4,r1              ;and 4,1
                xor r4,r0              ;xor 4,0         -c
                xor r0,r3              ;xor 0,3
                and r0,r1              ;and 0,1         -c
                xor r3,r4              ;xor 3,4
                rol r4,8                                ;-c
                xor r0,r3              ;xor 0,3
                rol r0,16                               ;-c
                xor r2,r3              ;xor 2,3

                mov r3,[esp+frame+rcnt]         ;-c
                rol r2,24                       ;-c
                lea r3,[r3*4];
                xor r1,[ebp+key0+r3*4]         ;-c
                xor r4,[ebp+key0+r3*4+4]         ;-c
                xor r0,[ebp+key0+r3*4+8]         ;-c
                xor r2,[ebp+key0+r3*4+12]         ;-c


;                mov esi,[esp+ciphertext+frame]
;                mov [esi+0],r1
;                mov [esi+4],r4
;                mov [esi+8],r0
;                mov [esi+12],r2
; redefine perspective
; r0=eax,r1=ebx,r2=ecx,r3=edx,r4=edi
; r0=r1 ,r1=r4 ,r2=r0 ,r3=r2 ,r4=r3

%define r0 ebx
%define r1 edi
%define r2 eax
%define r3 ecx
%define r4 edx

                ;start s-box b
                mov r4,r0       ;r4 = r0
                or r0,r3        ;r0|= r3
                ;should synchronize for pentium here
                xor r3,r1       ;r3^= r1
                and r1,r4       ;r1&= r4
                xor r4,r2       ;r4^= r2
                xor r2,r3       ;r2^= r3
                and r3,r0       ;r3&= r0
                or r4,r1        ;r4|= r1
                xor r3,r4       ;r3^= r4
                xor r0,r1       ;r0^= r1
                and r4,r0       ;r4&= r0
                xor r1,r3       ;r1^= r3
                xor r4,r2       ;r4^= r2
                or r1,r0        ;r1|= r0
                xor r1,r2       ;r1^= r2
                xor r0,r3       ;r0^= r3
                mov r2,r1       ;r2 = r1
                or r1,r3        ;r1|= r3
                xor r1,r0       ;r1^= r0

                mov esi,[esp+ciphertext+frame]
                mov [esi+0],r1
                mov [esi+4],r2
                mov [esi+8],r3
                mov [esi+12],r4

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret


_starttsc:      rdtsc
                push ebp
                mov ebp,[esp+8]
                mov [ebp],eax
                mov [ebp+4],edx
                pop ebp
                ret

_gettsc:        rdtsc
                push ebp
                mov ebp,[esp+8]
                sub [ebp],eax
                sbb [ebp+4],edx
                pop ebp
                ret

                
                rdtsc
                push ebp
                mov ebp,[esp+8]
                mov [ebp],eax
                mov [ebp+4],edx
                pop ebp
                ret

_NESSIEblank:   push ebp
                push esi
                push edi
                push ebx

                mov esi,[esp+plaintext+frame]   ;cycle
                mov r0,[esi+0]          ;cycle
                mov r1,[esi+4]          ;cycle
                mov r2,[esi+8]          ;cycle
                mov r3,[esi+12]         ;cycle

                mov esi,[esp+ciphertext+frame]
                mov [esi+0],r0
                mov [esi+4],r1
                mov [esi+8],r2
                mov [esi+12],r4

                pop ebx
                pop edi
                pop esi
                pop ebp
                ret
