#include <stdio.h>
#include "nessie.h"

extern unsigned invbyteS[256];
extern unsigned byteS[256];

unsigned sbox0[16]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
u8 key0[32]={0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
             0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0};

void NESSIEsbox0(u32 datain[4],u32 dataout[4])
{
NESSIEbitslice(sbox0,datain,dataout);
}

int main(int argc, char *argv[])
{
u32 data[8],result[8],i,KH[4];
struct NESSIEstruct keystruct;
u8 plain[16]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
u8 cipher[16];

  data[0]=0xAAAA;
  data[1]=0xCCCC;
  data[2]=0xF0F0;
  data[3]=0xFF00;
  data[4]=0;
  data[5]=0;
  data[6]=0;
  data[7]=0;

  printf("Test data\n");
  printf("Initial Values %04x %04x %04x %04x\n",data[0],data[1],data[2],data[3]);
  NESSIEbitslice(sbox0,data,result);
  printf("sbox0 %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEsboxa(data,result);
  printf("sboxa %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEsboxb(data,result);
  printf("sboxb %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEsboxc(data,result);
  printf("sboxc %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);

  NESSIEisboxa(data,result);
  printf("isboxa %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEisboxb(data,result);
  printf("isboxb %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEisboxc(data,result);
  printf("isboxc %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);

  NESSIEsbox0(data,result);
  NESSIEsboxa(result,result);
  printf("sbox0&a %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEsbox0(data,result);
  NESSIEsboxb(result,result);
  printf("sbox0&b %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEsbox0(data,result);
  NESSIEsboxc(result,result);
  printf("sbox0&c %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);

  NESSIEsboxa(data,result);
  NESSIEisboxa(result,result);
  printf("sboxa&ia %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEsboxb(data,result);
  NESSIEisboxb(result,result);
  printf("sboxb&ib %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);
  NESSIEsboxc(data,result);
  NESSIEisboxc(result,result);
  printf("sboxc&ic %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);

  
  data[0]=0x00010203;
  data[1]=0x04050607;
  data[2]=0x08090a0b;
  data[3]=0x0c0d0e0f;

  NESSIEbytesub(data,result);
  printf("byteS %08x %08x %08x %08x\n",result[0],result[1],result[2],result[3]);

  data[0]=0x00010203;
  data[1]=0x04050607;
  data[2]=0x08090a0b;
  data[3]=0x0c0d0e0f;

  NESSIEibytesub(data,result);
  printf("ibyteS %08x %08x %08x %08x\n",result[0],result[1],result[2],result[3]);

  data[0]=0xAAAA;
  data[1]=0xCCCC;
  data[2]=0xF0F0;
  data[3]=0xFF00;

  NESSIEbytesub(data,result);
  NESSIEibytesub(result,result);
  printf("byteS&ibyteS %08x %08x %08x %08x\n",result[0],result[1],result[2],result[3]);

  for (i=0;i<256;i++) if (i!=invbyteS[byteS[i]]) break;
  if (i==256) printf("ByteS passed\n");
  else printf("ByteS failed\n");

  KH[0]=0;
  KH[1]=0;
  KH[2]=0;
  KH[3]=0;

  NESSIEkeyround(result,KH,0);
  NESSIEikeyround(result,KH,0);
  printf("keyround and ikeyround 0 %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);

  NESSIEkeyround(result,KH,1);
  NESSIEikeyround(result,KH,1);
  printf("keyround and ikeyround 1 %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);

  NESSIEkeyround(result,KH,2);
  NESSIEikeyround(result,KH,2);
  printf("keyround and ikeyround 2 %04x %04x %04x %04x\n",result[0],result[1],result[2],result[3]);

  NESSIEperm(data,result);
  NESSIEiperm(result,result);
  printf("perm and iperm %08x %08x %08x %08x\n",result[0],result[1],result[2],result[3]);

  NESSIEkeysetup(key0,&keystruct);
 
  data[0]=keystruct.keyW2[0];
  data[1]=keystruct.keyW2[1];
  data[2]=keystruct.keyW2[2];
  data[3]=keystruct.keyW2[3];

  printf("KeyW2 %08x %08x %08x %08x\n",data[0],data[1],data[2],data[3]);
NESSIEikeyround(data,KH,ROUNDS+3);
  printf("Key%i %08x %08x %08x %08x\n",ROUNDS-1,data[0],data[1],data[2],data[3]);

  data[0]=keystruct.keyW2[0];
  data[1]=keystruct.keyW2[1];
  data[2]=keystruct.keyW2[2];
  data[3]=keystruct.keyW2[3];

  for (i=0;i<ROUNDS+3;i++)
	{
	NESSIEikeyround(data,KH,ROUNDS+3-i);
	}
  NESSIEikeyround(data,KH,ROUNDS+3-i);
  if (data[0]!=0) printf("error!\n");
  if (data[1]!=0) printf("error!\n");
  if (data[2]!=0) printf("error!\n");
  if (data[3]!=0) printf("error!\n");

  printf("W1 zero key %08x %08x %08x %08x\n",keystruct.keyW1[0],keystruct.keyW1[1],keystruct.keyW1[2],keystruct.keyW1[3]);
  printf("keyA zero key %08x %08x %08x %08x\n",keystruct.keyA[0],keystruct.keyA[1],keystruct.keyA[2],keystruct.keyA[3]);
  printf("keyB zero key %08x %08x %08x %08x\n",keystruct.keyB[0],keystruct.keyB[1],keystruct.keyB[2],keystruct.keyB[3]);
  for (i=0;i<ROUNDS;i++)
     printf("key%i zero key %08x %08x %08x %08x\n",i,keystruct.key[i][0],keystruct.key[i][1],keystruct.key[i][2],keystruct.key[i][3]);
  printf("W2 zero key %08x %08x %08x %08x\n",keystruct.keyW2[0],keystruct.keyW2[1],keystruct.keyW2[2],keystruct.keyW2[3]);
  
  data[0]=0xAAAAAAAA;
  data[1]=0xCCCCCCCC;
  data[2]=0xF0F0F0F0;
  data[3]=0xFF00FF00;

  printf("Initial Values %08x %08x %08x %08x\n",data[0],data[1],data[2],data[3]);
  NESSIEbytesubAB(&keystruct,data,result);
  printf("bytesubAB %08x %08x %08x %08x\n",result[0],result[1],result[2],result[3]);
  NESSIEibytesubAB(&keystruct,result,result);
  printf("ibytesubAB %08x %08x %08x %08x\n",result[0],result[1],result[2],result[3]);

  NESSIEround(&keystruct,data,result,1);
  printf("round %08x %08x %08x %08x\n",result[0],result[1],result[2],result[3]);
  NESSIEiround(&keystruct,result,result,1);
  printf("round %08x %08x %08x %08x\n",result[0],result[1],result[2],result[3]);

  printf("plain ");
  for (i=0;i<16;i++) printf("%02x ",plain[i]);
  printf("\n");

  NESSIEencrypt(&keystruct,plain,cipher);
  printf("encrypt ");
  for (i=0;i<16;i++) printf("%02x ",cipher[i]);
  printf("\n");
  NESSIEdecrypt(&keystruct,cipher,cipher);
  printf("decrypt ");
  for (i=0;i<16;i++) printf("%02x ",cipher[i]);
  printf("\n");

  for (i=0;i<1000;i++) NESSIEencrypt(&keystruct,cipher,cipher);
  printf("encrypt 1000 ");
  for (i=0;i<16;i++) printf("%02x ",cipher[i]);
  printf("\n");
  for (i=0;i<1000;i++) NESSIEdecrypt(&keystruct,cipher,cipher);
  printf("decrypt 1000 ");
  for (i=0;i<16;i++) printf("%02x ",cipher[i]);
  printf("\n");
  
  return 0;
}
